require 'gremlin/instruments'

module Gremlin
  module Instruments
    class Counter < Base
      def increment(labels={}, by=1)
        @r.hincrby retention_key, labels.to_json, by
      end

      def default
        0
      end

      def type
        :counter
      end

      def retention_key
        "gremlin_prometheus_#{node}_metrics_counter_#{name}"
      end

      def get(labels={})
        v = retention_get[labels.to_json]
        cast(v)
      end
    end
  end
end
