require 'gremlin/instruments'

module Gremlin
  module Instruments
    class Gauge < Base
      def set(labels={}, value)
        @r.hset retention_key, labels.to_json, value
        get(labels)
      end

      def type
        :gauge
      end

      def retention_key
        "gremlin_prometheus_#{node}_metrics_gauge_#{name}"
      end

      def get(labels={})
        v = retention_get[labels.to_json]
        cast(v)
      end
    end
  end
end
